package netscape.security;

public class AppletSecurityException extends SecurityException {
   Target target;

   public AppletSecurityException(String var1) {
      super(getProperty(var1));
      System.err.println("# Security Exception: " + var1);
      PrivilegeManager var2 = AppletSecurity.getPrivilegeManager();
      if (var2.getBoolPref("signed.applets.verbose_security_exception")) {
         ((Throwable)this).printStackTrace();
      }

   }

   public AppletSecurityException(String var1, String var2) {
      super(getProperty(var1) + ": " + var2);
      System.err.println("# Security Exception: " + var1 + ":" + var2);
      PrivilegeManager var3 = AppletSecurity.getPrivilegeManager();
      if (var3.getBoolPref("signed.applets.verbose_security_exception")) {
         ((Throwable)this).printStackTrace();
      }

   }

   public AppletSecurityException(String var1, String var2, String var3) {
      super(getProperty(var1) + ": " + var2);
      System.err.println("# Security Exception: " + var1 + ":" + var2 + ":" + var3);
      PrivilegeManager var4 = AppletSecurity.getPrivilegeManager();
      if (var4.getBoolPref("signed.applets.verbose_security_exception")) {
         ((Throwable)this).printStackTrace();
      }

   }

   private static String getProperty(String var0) {
      SecurityManager.enablePrivilege("UniversalPropertyRead");
      return System.getProperty("security." + var0, "security." + var0);
   }

   public AppletSecurityException(Target var1, String var2) {
      this(var2);
      this.target = var1;
   }

   public AppletSecurityException(Target var1, String var2, String var3) {
      this(var2, var3);
      this.target = var1;
   }

   public AppletSecurityException(Target var1, String var2, String var3, String var4) {
      this(var2, var3, var4);
      this.target = var1;
   }

   public String toString() {
      String var1 = super.toString();
      if (this.target != null) {
         var1 = var1 + "\n#  " + this.target.getName() + " privilege not enabled: " + this.target.getDescription();
      }

      return var1;
   }
}
