package netscape.security;

import netscape.util.Hashtable;

public class ParameterizedTarget extends UserTarget {
   private Hashtable itsPrinToPrivTable = new Hashtable();

   public ParameterizedTarget() {
   }

   public ParameterizedTarget(String var1, Principal var2, int var3, String var4, String var5, String var6) {
      super(var1, var2, var3, var4, var5, var6);
   }

   public ParameterizedTarget(String var1, Principal var2, int var3, String var4, String var5, String var6, String var7) {
      super(var1, var2, var3, var4, var5, var6, var7);
   }

   ParameterizedTarget(String var1, Principal var2) {
      super(var1, var2, UserDialogHelper.targetRiskHigh(), "", "", "");
   }

   public String getDetailedInfo(Object var1) {
      return var1 == null ? "" : var1.toString();
   }

   private void registerPrincipal(Principal var1) {
      Hashtable var2 = this.itsPrinToPrivTable;
      synchronized(var2){}

      try {
         if (this.itsPrinToPrivTable.get(var1) == null) {
            this.itsPrinToPrivTable.put(var1, new PrivilegeTable());
            return;
         }
      } catch (Throwable var5) {
         throw var5;
      }

   }

   void unregisterPrincipal(Principal var1) {
      Hashtable var2 = this.itsPrinToPrivTable;
      synchronized(var2){}

      try {
         this.itsPrinToPrivTable.remove(var1);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public Privilege enablePrivilege(Principal var1, Object var2) {
      Privilege var3 = super.enablePrivilege(var1, var2);
      if (var2 == null) {
         return var3;
      } else {
         this.registerPrincipal(var1);
         PrivilegeTable var4 = (PrivilegeTable)this.itsPrinToPrivTable.get(var1);
         var4.put(var2, var3);
         return var3;
      }
   }

   Privilege getPrincipalPrivilege(Principal var1, Object var2) {
      PrivilegeTable var3 = (PrivilegeTable)this.itsPrinToPrivTable.get(var1);
      return var3 != null && var2 != null ? var3.get(var2) : Privilege.findPrivilege(2, 1);
   }

   public Privilege checkPrivilegeEnabled(Principal[] var1, Object var2) {
      boolean var4 = false;
      int var5 = var1.length;

      while(var5-- > 0) {
         Privilege var3 = this.getPrincipalPrivilege(var1[var5], var2);
         switch (var3.getPermission()) {
            case 0:
            default:
               return Privilege.findPrivilege(0, 1);
            case 1:
               var4 = true;
            case 2:
         }
      }

      return var4 ? Privilege.findPrivilege(1, 1) : Privilege.findPrivilege(0, 1);
   }
}
